#include <Si4735.h>

#define DLF 10280
#define WDR5 8880
#define SWR3 9480

byte mode=FM; //mode 0 is FM, mode 1 is AM
Si4735 radio; //Create an instance of the Si4735 named radio.

void setup()
{Serial.begin(9600);
 pinMode(12,INPUT);
 digitalWrite(12,HIGH);
 radio.begin(mode);
 radio.tuneFrequency(DLF);
 radio.setDeemphasis(true);
 radio.setAM9(false);
 //pinMode(3, INPUT);
}

void loop()
{word frequency,PID; bool refresh=true;
 byte RSSI,SNR; char p[20],s[20],t[65],tt[12],d[11];
 //if(digitalRead(3)==1)radio.seek(true);
 if(Serial.available()>0)
 {switch(Serial.read())
  {case 'r':PID=radio.readRDS(s,t,tt,d);
            sprintf(p,"%04X",PID);
            Serial.print(p);  //HEX PID    (4)
            Serial.print(s);  //Sendername (8)
            Serial.print(tt); //Time      (11)
            Serial.print(d);  //Date       (10)
            Serial.println(t);//Text     (64+2)
            break;
   case '9':radio.setAM9(true);break;  //Bandbreite 9 kHz
   case '5':radio.setAM9(false);break; //Bandbreite 5 kHz
   case 'M':if (mode!=AM){radio.end();mode= AM; radio.begin(mode);}break;
   case 'L':if (mode!=LW){radio.end();mode= LW; radio.begin(mode);}break;           
   case 'K':if (mode!=SW){radio.end();mode= SW; radio.begin(mode);}break;
   case 'F':if (mode!=FM){radio.end();mode= FM; radio.begin(mode);}break;
   case 'v':sprintf(s,"%02d",radio.getVolume());
            Serial.println(s);
            break;
   case '1':radio.setMono(true);break;
   case '3':radio.setMono(false);break;
   case 'e':radio.setDeemphasis(true);break; //Europa
   case 'D':radio.tuneFrequency(DLF);break;
   case 'W':radio.tuneFrequency(WDR5);break;
   case '8':radio.volume(true);break;
   case '2':radio.volume(false);break;
   case '4':radio.seek(false);break;
   case '0':radio.getRSQ(&RSSI,&SNR);
           sprintf(s,"%02d/%02d",RSSI,SNR);
           Serial.println(s);
           break;
   case 'm':radio.mute(true);  break;
   case 'u':radio.mute(false);break;
   case '6':radio.seek(true);   break;  
   case 'f':
           frequency=radio.getFrequency(refresh);
           if(mode==FM)sprintf(s,"%3d,%d MHz", (int)(frequency/100),(int)(frequency%100)/10);
           else sprintf(s,"%5d kHz",frequency);
           Serial.println(s);
           break;
   case 's':Serial.println((byte)radio.getStatus(),HEX);
   default: break;
  }
 }   
}

